// ***************************************************************************
// Implementation System Includes
// ***************************************************************************
 
#include <add-ons/tracker/TrackerAddon.h>           // Exports process_refs().

#include <Alert.h>
#include <Application.h>

// ***************************************************************************
// Implementation Project Includes
// ***************************************************************************

#include "StyleGuideDefs.h"         // Standard type and constant definitions.

#include "Main.h"
#include "SelectiveWindow.h"
#include "Version.h"

// ***************************************************************************
// Implementation Constant Definitions
// ***************************************************************************

// ***************************************************************************
// Implementation Type Definitions
// ***************************************************************************

// ***************************************************************************
// Implementation Variable Definitions
// ***************************************************************************

// ***************************************************************************
// Implementation Function Declarations
// ***************************************************************************

/** Shows the about window. */
static void ShowAboutWindow();

// ***************************************************************************
// Global Variable Definitions
// ***************************************************************************

// ***************************************************************************
// PUBLIC Member Function Definitions: Lifecycle
// ***************************************************************************

// ***************************************************************************
// PUBLIC Member Function Definitions: Operators
// ***************************************************************************

// ***************************************************************************
// PUBLIC Member Function Definitions: Operations
// ***************************************************************************

// ***************************************************************************
// PUBLIC Member Function Definitions: Access
// ***************************************************************************

// ***************************************************************************
// PUBLIC Member Function Definitions: Inquiry
// ***************************************************************************

// ***************************************************************************
// PROTECTED Member Function Definitions
// ***************************************************************************

// ***************************************************************************
// PRIVATE Member Function Definitions
// ***************************************************************************

// ***************************************************************************
// Helper Function Definitions
// ***************************************************************************

// ***************************************************************************
// Global Function Definitions
// ***************************************************************************

// ===========================================================================
// process_refs
// ===========================================================================

// Paraphrased from the Be Book: The Tracker calls this function when the 
// user invokes the add-on. The current directory is found in aDirRef. 
// apMessage is a standard B_REFS_RECEIVED BMessage with the "refs" array 
// containing the entry_refs of the files selected by the user. The third 
// argument is currently unused.

void
process_refs(entry_ref aDirRef, BMessage* apMessage, void* apReserved) 
{ 
  // Create the window. This starts our main loop.
  tSelectiveWindow* lpWindow = new tSelectiveWindow(aDirRef, apMessage);
  
  // Wait until the window thread terminates. If we don't do this, our
  // add-on might crash mysteriously, taking the Tracker with it. See also
  // "Be Newsletter Volume II Issue 10".
  tInt32 lExitValue;
  wait_for_thread(lpWindow->Thread(), &lExitValue);
}

// ===========================================================================
// main
// ===========================================================================

// An add-on is not required to have a main() function. But if it does, 
// the user can run the add-on as a stand-alone application as well. We 
// just show a simple about window.

int
main() 
{
  BApplication app("application/x-vnd.mahlzeit.selective");
  ShowAboutWindow();
  return 0;
}

// ***************************************************************************
// Implementation Function Definitions
// ***************************************************************************

// ===========================================================================
// ShowAboutWindow
// ===========================================================================

static void
ShowAboutWindow()
{
  (new BAlert(0,
          "Selective -- Select files using wildcards\n\n"
          "Version " VERSION_STRING "\n"
          "Released on " VERSION_DATE_STRING "\n\n"
          "Matthijs Hollemans\n"
          "mahlzeit@bigfoot.com\n"
          "http://home.concepts.nl/~hollies/",
          "Okay",
          0,
          0,
          B_WIDTH_AS_USUAL,
          B_INFO_ALERT))->Go();
}
